#ifndef OCR_H
#define OCR_H

#define _GNU_SOURCE

#include <pam.h>
#include <stdint.h>
#include <inttypes.h>
#include <assert.h>
#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include <stdarg.h>
#include <time.h>

#include <sys/types.h>
#include <sys/wait.h>
#include <sys/time.h>


typedef struct {
  int w,h;
  char d[];
} CanonImage;


typedef uint32_t Pixcol;
#define PSPIXCOL(priscan) priscan##32

typedef struct {
  const char *s; /* valid until next call to ocr() */
  int l,r; /* column numbers */
  unsigned ctxmap; /* match context index */
} OcrResultGlyph;

typedef const struct OcrCellTypeInfo *OcrCellType;
extern const struct OcrCellTypeInfo ocr_celltype_text;
extern const struct OcrCellTypeInfo ocr_celltype_number;

typedef struct OcrReader OcrReader;
OcrReader *ocr_init(int h);

OcrResultGlyph *ocr(OcrReader *rd, OcrCellType, int w, Pixcol cols[]);
  /* return value is array terminated by {0,-1,-1}
   * array is valid until next call to ocr()
   */

void debug_flush(void);

#define eassert assert
#define debug stdout

const char *get_vardir(void);

CanonImage *file_read_image(FILE *f);
int main_test(void);

#define MAX_PAGES 100
extern CanonImage *page_images[MAX_PAGES];
extern int npages;


#define DEBUG_RECTANGLES
// #define DEBUG_OCR

#endif /*OCR_H*/
